import { Adapter as $64$luvio_engine_Adapter, Snapshot as $64$luvio_engine_Snapshot, UnfulfilledSnapshot as $64$luvio_engine_UnfulfilledSnapshot, AdapterConfigMetadata as $64$luvio_engine_AdapterConfigMetadata } from '@luvio/engine';
export declare const ObjectPrototypeHasOwnProperty: (v: PropertyKey) => boolean;
declare const ObjectKeys: {
    (o: object): string[];
    (o: {}): string[];
}, ObjectCreate: {
    (o: object | null): any;
    (o: object | null, properties: PropertyDescriptorMap & ThisType<any>): any;
};
export { ObjectCreate, ObjectKeys };
export declare const ArrayIsArray: (arg: any) => arg is any[];
export declare const ArrayPrototypePush: (...items: any[]) => number;
export interface AdapterValidationConfig {
    displayName: string;
    parameters: {
        required: string[];
        optional: string[];
        unsupported?: string[];
    };
}
/**
 * Validates an adapter config is well-formed.
 * @param config The config to validate.
 * @param adapter The adapter validation configuration.
 * @param oneOf The keys the config must contain at least one of.
 * @throws A TypeError if config doesn't satisfy the adapter's config validation.
 */
export declare function validateConfig<T>(config: Untrusted<T>, adapter: AdapterValidationConfig, oneOf?: string[]): void;
export declare function untrustedIsObject<Base>(untrusted: unknown): untrusted is Untrusted<Base>;
export type UncoercedConfiguration<Base, Options extends {
    [key in keyof Base]?: any;
}> = {
    [Key in keyof Base]?: Base[Key] | Options[Key];
};
export type Untrusted<Base> = Partial<Base>;
export declare function areRequiredParametersPresent<T>(config: any, configPropertyNames: AdapterValidationConfig): config is T;
export declare function refreshable<C, D, R>(adapter: $64$luvio_engine_Adapter<C, D>, resolve: (config: unknown) => Promise<$64$luvio_engine_Snapshot<R>>): $64$luvio_engine_Adapter<C, D>;
export declare const SNAPSHOT_STATE_FULFILLED = "Fulfilled";
export declare const SNAPSHOT_STATE_UNFULFILLED = "Unfulfilled";
export declare const snapshotRefreshOptions: {
    overrides: {
        headers: {
            'Cache-Control': string;
        };
    };
};
/**
 * A deterministic JSON stringify implementation. Heavily adapted from https://github.com/epoberezkin/fast-json-stable-stringify.
 * This is needed because insertion order for JSON.stringify(object) affects output:
 * JSON.stringify({a: 1, b: 2})
 *      "{"a":1,"b":2}"
 * JSON.stringify({b: 2, a: 1})
 *      "{"b":2,"a":1}"
 * @param data Data to be JSON-stringified.
 * @returns JSON.stringified value with consistent ordering of keys.
 */
export declare function stableJSONStringify(node: any): string | undefined;
export declare function getFetchResponseStatusText(status: number): string;
export declare function isUnfulfilledSnapshot<T, U>(snapshot: $64$luvio_engine_Snapshot<T, U>): snapshot is $64$luvio_engine_UnfulfilledSnapshot<T, U>;
export declare function generateParamConfigMetadata(name: string, required: boolean, resourceType: $64$luvio_engine_AdapterConfigMetadata['resourceType'], typeCheckShape: $64$luvio_engine_AdapterConfigMetadata['typeCheckShape'], isArrayShape?: boolean, coerceFn?: (v: unknown) => unknown): $64$luvio_engine_AdapterConfigMetadata;
export declare function buildAdapterValidationConfig(displayName: string, paramsMeta: $64$luvio_engine_AdapterConfigMetadata[]): AdapterValidationConfig;
export declare const keyPrefix = "Apex";
